<template>
  <div class="px-2 py-6 space-y-2">
    <div
      v-if="paymentWithdrawalTextInfo?.Text?.length > 0"
      class="pb-4 mb-4 text-sm rounded font-normal --text2 txt-info"
      v-html="paymentWithdrawalTextInfo?.Text"
    ></div>
    <h5
      class="text-4w"
      v-if="
        cryptocurrencyRadios.radios && cryptocurrencyRadios.radios.length > 0
      "
    >
      {{ $t("choose_your_cryptocurrency_network") }}
    </h5>
    <el-radio-group
      v-model="selectCryptoCurrency"
      class="grid grid-cols-2 gap-2 crypto-currency-network"
    >
      <el-radio-button
        v-for="crypto in cryptocurrencyRadios.radios"
        :key="crypto"
        :label="crypto"
        border
      >
        <img
          class="absolute check-img"
          :src="getAssetImage('assets/svg-icon/checked.svg')"
          alt="check"
        />
        {{ crypto }}
      </el-radio-button>
    </el-radio-group>
  </div>
  <div class="px-2 py-6">
    <el-form
      ref="ruleFormRef"
      :model="formData"
      status-icon
      :rules="getRule"
      :label-position="labelPosition"
      label-width="210px"
      :validate-on-rule-change="false"
    >
      <el-form-item :label="$t('wallet_address')" prop="walletAddress">
        <el-input
          v-model="formData.walletAddress"
          v-un-focus
          oninput="this.value = this.value.replace(/[^a-zA-Z0-9]/g, '')"
        ></el-input>
      </el-form-item>
      <template v-if="isWithdrawalLimitEnabled">
        <el-form-item v-if="isAllowEligibleWithdrawal" :label="$t('eligible_withdrawal')">
          <div class="fc-primary font-bold">{{ eligibleWithdrawal }}</div>
        </el-form-item>
        <el-form-item prop="withdrawalLimit" :label="$t('remaining_rollover')">
          {{ remainingRollover }}
        </el-form-item>
      </template>
      <el-form-item :label="$t('amount')" prop="amount">
        <el-input
          v-model="formData.amount"
          v-un-focus
          @input="onInputValue($event, formData, 'amount')"
          :placeholder="amountPlaceholder"
          @change="refreshTransactionFee"
        >
          <template v-if="checkedCurrency" #append>
            <span>000</span>
          </template>
        </el-input>
        <div class="block">
          <span
            v-if="checkedCurrency"
            class="order-1 text-xs fc-hint mt-3 block">{{
              $t(
                `withdrawal_amount_shown_by_the_system_${profile.Currency.toLowerCase()}`
              )
          }}</span>
        </div>
        <div class="block">
          <div>
            {{ $t("transaction_fee") }} : {{ TransactionFee }} USDT
            <icons :is-refresh="true" @click="refreshTransactionFee" />
          </div>
        </div>
      </el-form-item>
      <el-form-item
        v-if="isPaymentPasswordEnable"
        :label="$t('payment_password')"
        prop="paymentPassword"
      >
        <el-input
          v-model="formData.paymentPassword"
          v-un-focus
          type="password"
        ></el-input>
      </el-form-item>
    </el-form>
    <div class="mt-10 text-center submit-button-deposit submit-button-deposit">
      <el-button
        type="primary"
        round
        :disabled="isWithdrawProcessing"
        @click="submitWithdrawal(ruleFormRef)"
        >{{ $t("continue") }}</el-button
      >
    </div>
  </div>
</template>
<script lang="ts">
import { defineComponent, PropType, toRefs, ref } from "vue";
import { useCryptoCurrencyWithdrawal } from "@/composables/payment/withdrawal/useCryptoCurrencyWithdrawal";
import { usePaymentBankTransferWithdrawal } from "@/composables/payment/withdrawal/usePaymentBankTransferWithdrawal";
import { IGetPaymentGatewayBanksResponse } from "@/models/getPaymentGatewayBanksRespone";
import { ProfileDto } from "@/models/getProfileResponse";

export default defineComponent({
  props: {
    paymentBanks: {
      type: Object as PropType<IGetPaymentGatewayBanksResponse>,
      required: true,
    },
    profile: {
      type: Object as PropType<ProfileDto>,
      required: true,
    },
    isPaymentPasswordEnable: {
      type: Boolean,
      default: false,
    },
    isWithdrawalLimitEnabled: {
      type: Boolean,
      default: false,
    },
  },
  setup(props) {
    const {
      paymentBanks,
      profile,
      isPaymentPasswordEnable,
      isWithdrawalLimitEnabled,
    } = toRefs(props);
    const labelPosition = ref("top");
    const {
      selectCryptoCurrency,
      withdrawalMin,
      withdrawalMax,
      cryptocurrencyRadios,
      refreshTransactionFee,
      TransactionFee,
      submitWithdrawal,
      getRule,
      formData,
      ruleFormRef,
      isWithdrawProcessing,
      checkedCurrency,
      amountPlaceholder,
      remainingRollover,
      eligibleWithdrawal,
    } = useCryptoCurrencyWithdrawal(
      paymentBanks,
      profile,
      isPaymentPasswordEnable,
      isWithdrawalLimitEnabled
    );
    const {
      paymentWithdrawalTextInfo,
    } = usePaymentBankTransferWithdrawal(
      paymentBanks,
      profile,
      isPaymentPasswordEnable,
      isWithdrawalLimitEnabled
    );
    const { getAssetImage, onInputValue, allowCompany, isAllowEligibleWithdrawal } = commonHelper;
    return {
      selectCryptoCurrency,
      withdrawalMin,
      withdrawalMax,
      cryptocurrencyRadios,
      refreshTransactionFee,
      TransactionFee,
      submitWithdrawal,
      getRule,
      formData,
      ruleFormRef,
      isWithdrawProcessing,
      checkedCurrency,
      labelPosition,
      amountPlaceholder,
      remainingRollover,
      eligibleWithdrawal,
      getAssetImage,
      paymentWithdrawalTextInfo,
      onInputValue,
      allowCompany,
      isAllowEligibleWithdrawal,
    };
  },
});
</script>
<style scoped lang="scss">
[layout="peru"] {
  @media (max-width: 639px) {
    .txt-info {
        padding: 0;
      }
  }
}
</style>
<style lang="scss">
  [theme-color="main_lightblue"] {
    .text-4w {
      color: var(--text5) !important;
    }
    .crypto-currency-network .el-radio-button__inner  {
      color: var(--text5);
    }
}
</style>
